/*/////////////////////////////////////////////////////////*/
#include <stdio.h>
#include "ecatdmodpistruct.h"
#include "ethercatdef.h"
#include <const.h>
#include <stddef.h>
#include <sysglob.h>
#include <signal.h>
#include <pthread.h>
#define HOME	"\x1b[H"
#define CLRSC 	"\x1b[2J"

u_int32 ticps () // 
{

	glob_buff myg;
	_os_getsys (offsetof(sysglobs, d_tcksec ),sizeof(u_int16),&myg);
	return myg.wrd;

}

int main (int argc,char**argv) {

	char* pilay = "ECAT_pi_layout";
	char* piin = "ECAT_pi_in";
	char* piout= "ECAT_pi_out";
	char* evnam = "ECAT_pi_ev_sync";
	error_code myerr;
	signal_code sig;
	u_int32 hits,timeout,inval,zval;
	int32 adval;
	struct ecat_off_len digin;
	struct ecat_off_len digout,dig8out;
	struct ecat_off_len daout1;
	struct ecat_off_len daout2;
	struct ecat_off_len dain1;
	struct ecat_off_len dain2;
	int32 idxvar,idx,i;
	char names1[256],names2[256];

	if((myerr= ecat_accpi_open(piin,piout,pilay,evnam))!=SUCCESS) exit(myerr);

	/*	ad1.1 is inputvar nr 2 and uint16
		ad1.2 is inputvar nr 4 and uint16
		di1.1-1.4 is inputvar nr 5,6,7,8 each 1 bit
		di2.1-2.4 is inputvar nr 9,10,11,12 each 1 bit
	    
		da1.1 is outputvar nr 1 and u_int16
		da1.2 is outputvar nr 2 and u_int16
		do1.1-1.4 is outputvar nr 3,4,5,6 each 1 bit
		do2.1-2.4 is outputvar nr 7,8,9,10 each 1 bit
	*/
	/* link to ecat syc event*/

	idxvar=1;
	for(;idxvar>0;){
		ecat_accpi_get_nxt_entry(names1,names2,&idxvar );
	}

	if((myerr= ecat_accpi_in_varbyidx(2,&dain1))!=SUCCESS) exit(myerr);
	if((myerr= ecat_accpi_in_varbyidx(4,&dain2))!=SUCCESS) exit(myerr);
	if((myerr= ecat_accpi_out_varbyidx(1,&daout1))!=SUCCESS) exit(myerr);
	ecat_pi_out(-32000,daout1);
	if((myerr= ecat_accpi_out_varbyidx(2,&daout2))!=SUCCESS) exit(myerr);
	if((myerr= ecat_accpi_in_varbyidx(7,&digin))!=SUCCESS) exit(myerr);


	if((myerr= ecat_accpi_find_in_var(ECAT_IN1,&dain1))!=SUCCESS) exit(myerr);
	if((myerr= ecat_accpi_find_in_var(ECAT_IN3,&dain2))!=SUCCESS) exit(myerr);
	if((myerr= ecat_accpi_find_out_var(ECAT_OUT0,&daout1))!=SUCCESS) exit(myerr);
	ecat_pi_out(-32000,daout1);
	if((myerr= ecat_accpi_find_out_var(ECAT_OUT1,&daout2))!=SUCCESS) exit(myerr);
	if((myerr= ecat_accpi_find_in_var(ECAT_IN4,&digin))!=SUCCESS) exit(myerr);
	digin.len=8; /*just for fun we have 8 bits in and out  */
	if((myerr= ecat_accpi_find_out_var(ECAT_OUT2,&digout))!=SUCCESS) exit(myerr);
	digout.len=8;
	ecat_pi_out(0,digout);

	inval=zval=0;
	adval=-32000;
	printf("%s",CLRSC);

	do {

		/* wait for ethercat cycle finish*/
		if( (myerr= ecat_pi_wait()) !=SUCCESS) exit(myerr);
		/* now ethercat cycle waits until we are done*/
		inval= ecat_pi_in(digin);
		
		if(++zval>255) zval=0;
		if(++adval>32000) adval=-32000;
		ecat_pi_out(zval,digout);
		ecat_pi_out(adval,daout2);
		printf("%scounter:%d  ad1:%i  ad2: %i \n",HOME,inval,(int16)ecat_pi_in(dain1),(int16)ecat_pi_in(dain2));

		/*we are done--------------*/
		if((myerr= 	ecat_pi_trigger())!=SUCCESS) exit(myerr);
		timeout=ticps()/100;
		_os_sleep(&timeout,&sig);  /*wait 10 ms*/
		_os_gs_ready(0,&hits);
	} while (hits==0); /* loop until any key hit*/
	printf("\n\n");
	if((myerr=ecat_accpi_close())) exit(myerr);	 
	return 0;
}
