#ifndef _ECATDMODPISTRUCT
#define _ECATDMODPISTRUCT
#ifdef __cplusplus 
  extern "C" { 
#endif //* __cplusplus *// 

#include <types.h>
/* all offxx components are byteoffsets from start of variable containing offxx entry
   if an offset is zero then it does not exist; all strings are ascii and zero terminated
   german ae,ue,oe are coded in one byte

	pi layout in datmod is an array of <maxnumber> size, each field is of type struct ecat_pi_layout;
	layout of datamodul ecat_pi_struct:
		
		struct ecat_pi_layout objects[maxnumber]

    An entry is either a input/output variable or a describtion of pi size.

   remark: all bitoffsets are offsets relativ to the start of ecat input or output processimage 
           (the magic number 208 is already encountered). bytesize is the size of the input or 
		   output processimage. the processimages are each a seperate datamodul


*/
#define MAXTYPE 16
#define ECAT_PATH_IN_BYTESIZE "/EtherCATConfig/Config/ProcessImage/Inputs/ByteSize"
#define ECAT_PATH_OUT_BYTESIZE "/EtherCATConfig/Config/ProcessImage/Outputs/ByteSize"
#define ECAT_PATH_IN_VAR "/EtherCATConfig/Config/ProcessImage/Inputs/Variable"
#define ECAT_PATH_OUT_VAR "/EtherCATConfig/Config/ProcessImage/Outputs/Variable"

typedef struct ecat_pi_layout {

	 u_int32 number; /* the  first entry in datamodul has <maxnumber> 
	                    the last is not zero but one */

	/* Prfix of each path must contain 
	    /EtherCATConfig/Config/ProcessImage/
	  followed by:	
		Inputs/
		     ByteSize   #only then  iBytesize is valid
			 Variable   #only then iBitSize,iBitOffs and Datatype are valid
		Outputs/
		     ByteSize
			 Variable
	*/
	u_int32 offpath;	/* path of entry related to xml element namepath
				 			root element in hierachy of xml file is
							EtherCATConfig ending with either 
							Inputs/Variable or Outputs/Variable or
							Inputs/ByteSize or Outputs/Bytesize */
						/* offset first char relativ to fieldelement start*/
	u_int32 offname;	/* If path indicates Variable then
						   name of Variable eg. "EL1004 Channel.Input 1"
						/* offset first char relativ to fieldelement start*/ 
	char DataType[MAXTYPE];	/* text coded datatyp of Variable
								 BOOL=1 Bit,BYTE,UINT=16 bit,*/
	u_int32 offComment; /* Comment which gives sometimes info about interpretation
						   of Variable values*/
						/* offset first char relativ to fieldelement start*/ 
							
						/* is valid if not zero*/
	u_int32 iBitSize;	/* length of Variable in bits */
	u_int32 iBitOffs;	/* real! offset of variable  in bits from startadress of pi inout datamodul 
	                        startadress of dataarea (differs from xml textual entry by 208!!*/
	u_int32 iBytesize;	/* in case of path ending wzih /ByteSize
						   number of bytes in processimage which is the 
						   length of input/output datamodul (the magic not exiting bytes
						   are already substracted =>-208/8)*/
} ECAT_PI_LAYOUT;

/*--------------------------------------------------------------------------------*/
typedef struct ecat_anz_byt_ele 
{
	int anzbyt;
	int anzele;
} ECAT_ANZ_BYT_ELE;

typedef struct ecat_off_len 
{	
	u_int32 off;
	u_int32 len;
} ECAT_OFF_LEN;


void ecat_pi_out(u_int32 ,struct ecat_off_len );
u_int32 ecat_pi_in(struct ecat_off_len );

error_code ecat_accpi_out_varbyidx(u_int32 ,struct ecat_off_len *);
u_int32 ecat_accpi_out_varanz();
error_code ecat_accpi_in_varbyidx(u_int32 ,struct ecat_off_len *);
u_int32 ecat_accpi_in_varanz();

error_code ecat_accpi_find_out_var(char*,struct ecat_off_len *);
error_code ecat_accpi_find_in_var(char*,struct ecat_off_len *);

u_int32 ecat_accpi_inout_size();

error_code ecat_accpi_open(char* pi_in,char* pi_out,char* pi_lay,char* );
error_code ecat_accpi_close();

error_code ecat_pi_wait() ;
error_code ecat_pi_trigger() ;

error_code ecat_accpi_get_nxt_entry(char*,char*,int32* );

#ifdef __cplusplus 
  }
#endif //* __cplusplus *//

#endif
